// Coded by Erik van de Coevering 
// DSP-style low-pass filters designed with Matlab's FDAtool. 
// For information on how to implement these filters, check this pdf: http://spinlab.wpi.edu/courses/ece4703_2009/how_to_interpret_matlab_dfii_sos.pdf

#include "LPfilter.h"

float LPfilter::run(float input) {
	filterbuffer[2] = filterbuffer[1];
	filterbuffer[1] = filterbuffer[0];
	filterbuffer[0] = input*LP_A + filterbuffer[1]*LP_B + filterbuffer[2]*LP_C;

	out = filterbuffer[0]*LP_D + filterbuffer[1]*LP_E + filterbuffer[2]*LP_F;
	return out;
}

float LPfilter2::run(float input) {
	filterbuffer1[2] = filterbuffer1[1];
	filterbuffer1[1] = filterbuffer1[0];
	filterbuffer1[0] = input*0.003762202981699 + filterbuffer1[1]*1.893415601023 + filterbuffer1[2]*-0.9084644129493;
	
	out_temp = filterbuffer1[0] + filterbuffer1[1]*2.0f + filterbuffer1[2];
	
	filterbuffer2[2] = filterbuffer2[1];
	filterbuffer2[1] = filterbuffer2[0];
	filterbuffer2[0] = out_temp*0.003533495923378 + filterbuffer2[1]*1.778313488139 + filterbuffer2[2]*-0.7924474718329;
	
	out = filterbuffer2[0] + filterbuffer2[1]*2.0f + filterbuffer2[2];
	return out;
}

float LPfilter2_1::run(float input) {
	filterbuffer1[2] = filterbuffer1[1];
	filterbuffer1[1] = filterbuffer1[0];
	filterbuffer1[0] = input*0.007954132308248 + filterbuffer1[1]*1.836787188551 + filterbuffer1[2]*-0.8686037177835;
	
	out_temp = filterbuffer1[0] + filterbuffer1[1]*2.0f + filterbuffer1[2];
	
	filterbuffer2[2] = filterbuffer2[1];
	filterbuffer2[1] = filterbuffer2[0];
	filterbuffer2[0] = out_temp*0.007277930990548 + filterbuffer2[1]*1.680637168775 + filterbuffer2[2]*-0.7097488927369;
	
	out = filterbuffer2[0] + filterbuffer2[1]*2.0f + filterbuffer2[2];
	return out;
}

